#ifndef WRSL
#define WRSL
#include "WTL.H"
#define CONST_RS      1.414213562373095146
//======================================================================
//  
// 
scomplex U_RealSh(integer k) {
    TRIG_VVARS;
    for(i=0;i<k;i++) {
    if(i==k/4) S.Mas[i]=SET_ELEM(0,1);
    else if(i==3*k/4) S.Mas[i]=SET_ELEM(0,-1);
         else if(i>k/4 && i<3*k/4) S.Mas[i]=SET_ELEM(0,0);
              else S.Mas[i]=SET_ELEM(CONST_RS,0);
    }
    S=FFT(S,-1);
    return S;
};
//======================================================================
// 
scomplex V_RealSh(integer k) {
    TRIG_VVARS;
    for(i=0;i<k;i++) {
    if(i==k/4 || i==3*k/4) S.Mas[i]=SET_ELEM(1,0);
    else if(i>k/4 && i<3*k/4) S.Mas[i]=SET_ELEM(CONST_RS,0);
              else S.Mas[i]=SET_ELEM(0,0);
    }
    S=FFT(S,-1);
    return S;
};
//======================================================================
//   :
scomplex* Filtrs_RealSh(integer k,integer p) {
    TRIG_FVARS
    WORK(RealSh)
    FREE_MEMORY
    return Filtr;
}
//======================================================================
//         
integer RealSh_MAX_ITER(integer k) {
    integer p=0;
    real d=k;
    while(1) {
		d/=2;
		if(d==(integer)d) p++;
		else break;
	}
    if(p) return p-2;
    return p;
};
#endif
